(function() {
  var utils, websocket_hixie76, websocket_hybi10;
  utils = require('./utils');
  websocket_hixie76 = require('./trans-websocket-hixie76');
  websocket_hybi10 = require('./trans-websocket-hybi10');
  exports.app = {
    websocket: function(req, connection, head) {
      var location, origin, ver;
      if (req.headers.upgrade.toLowerCase() !== 'websocket') {
        throw {
          status: 406,
          message: "Can upgrade only to websockets."
        };
      }
      origin = req.headers.origin;
      if (!utils.verify_origin(origin, req.sockjs_server.options.origins)) {
        throw {
          status: 403,
          message: "Unverified origin."
        };
      }
      location = (origin && origin.slice(0, 5) === 'https' ? 'wss' : 'ws');
      location += '://' + req.headers.host + req.url;
      ver = req.headers['sec-websocket-version'];
      if (ver === '8' || ver === '7') {
        new websocket_hybi10.WebHandshake8(req, connection, head || '', origin, location);
      } else {
        new websocket_hixie76.WebHandshakeHixie76(req, connection, head || '', origin, location);
      }
      return true;
    }
  };
}).call(this);
